package hr.effectiva.html.pdf.api.examples;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.message.BasicNameValuePair;

public class GeneratePdfByHtml {
    public static void main(String[] args) throws UnsupportedEncodingException, FileNotFoundException, IOException {
        // set data for request
        String apiUrl = "http://htmlpdfapi.com/api/v1/pdf";
        String html = "<!DOCTYPE html><html><head><meta charset=\"UTF-8\"></head><body>Hello world!!!</body></html>";
        
        // create HTTP POST
        HttpClient client = HttpClientBuilder.create().build();
        HttpPost post = new HttpPost(apiUrl);
        
        // set HTTP header property
        post.setHeader("Authentication", "Token <your token>"); // Don't forget to change the token!!!
        
        // set HTTP POST parameters
        List<NameValuePair> urlParameters = new ArrayList<NameValuePair>();
        urlParameters.add(new BasicNameValuePair("html", html));
        post.setEntity(new UrlEncodedFormEntity(urlParameters));
        
        // get response stream and save to the file
        HttpResponse response = client.execute(post);
        if(response.getStatusLine().getStatusCode() == HttpStatus.SC_OK){
            InputStream responseStream = response.getEntity().getContent();
            FileOutputStream outputStream = new FileOutputStream("result.pdf");

            int bytesRead = -1;
            byte[] buffer = new byte[4096];
            while ((bytesRead = responseStream.read(buffer)) != -1) {
                outputStream.write(buffer, 0, bytesRead);
            }

            // close streams
            outputStream.close();
            responseStream.close();
        }else{
            System.out.println("Error: " + response.getStatusLine());
        }
    }
}
